﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Cargold.WhichOne;

public class Character_Script : MonoBehaviour, IWhichOne
{
    [SerializeField] private CharacterType characterType;
    [SerializeField, TextArea(0, 2)] private string charName;
    [SerializeField] private SpriteRenderer spriteRenderer;
    public bool IsLiar { get; private set; }
    private string speech;
    private int characterNum;
    private bool isAlive;    

    public CharacterType CharacterType { get { return characterType; } }
    public string CharName { get { return charName; }  }
    public Sprite CharSprite { get { return spriteRenderer.sprite; } }
    public bool IsAlive { get => isAlive; }

    public void Activate_Func(bool _isLiar, string _speech, Vector2 _pos)
    {
        IsLiar = _isLiar;

        speech = _speech;

        this.transform.position = _pos;

        isAlive = true;
    }

    public void Kill_Func()
    {
        if(isAlive == true)
        {
            isAlive = false;

            StartCoroutine(KillEffect_Cor());
        }
        else
        {
            Debug_C.Error_Func("?");
        }
    }
    private IEnumerator KillEffect_Cor()
    {
        for (float i = 1f; 0f < i;)
        {
            i -= Time.deltaTime;

            spriteRenderer.color = new Color(i, i, i, 1f);

            yield return null;
        }

        //_2dxFX_Ghost _ghostFx = spriteRenderer.gameObject.AddComponent<_2dxFX_Ghost>();

        //for (float i = 0f; i < 1f;)
        //{
        //    i += Time.deltaTime;

        //    _ghostFx._Alpha = 1f - i;
        //    _ghostFx._ClipDown = i;
        //    _ghostFx._ClipLeft = i;
        //    _ghostFx._ClipUp = i;
        //    _ghostFx._ClipRight = i;
        //    _ghostFx._offset = i;

        //    yield return null;
        //}

        //_ghostFx._Alpha = 0f;
        //_ghostFx._ClipDown = 1f;
        //_ghostFx._ClipLeft = 1f;
        //_ghostFx._ClipUp = 1f;
        //_ghostFx._ClipRight = 1f;
        //_ghostFx._offset = 1f;
    }

    public void Deactivate_Func()
    {
        GameObject.Destroy(this.gameObject);
    }

    void IWhichOne.Selected_Func(bool _repeat)
    {
        UI_DialogManager.Instance.Activate_Func(this);
    }

    void IWhichOne.SelectCancel_Func()
    {

    }

    public void Select_Func()
    {
        StageSystem_Manager.Instance.SelectCharClass_Func(this);
    }
}
