﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameSystem_Manager : MonoBehaviour
{
    [SerializeField] private DataBase_Manager dataBase_Manager;

    [SerializeField] private StageSystem_Manager StageManager;
    [SerializeField] private CameraSystem_Manager cameraSystem_Manager;
    [SerializeField] private SoundSystem_Manager soundSystem_Manager;

    [SerializeField] private UI_Intro_Manager uI_Intro_Manager;
    [SerializeField] private UI_DialogManager uI_DialogManager;
    [SerializeField] private UI_Status_Manager uI_Status_Manager;
    [SerializeField] private UI_SceneChange_Manager uI_SceneChange_Manager;
    [SerializeField] private UI_Victory_Manager uI_Victory_Manager;

    private void Awake()
    {
        GameObject _dbObj = GameObject.Instantiate(dataBase_Manager.gameObject);
        dataBase_Manager = _dbObj.GetComponent<DataBase_Manager>();
        dataBase_Manager.Init_Func();
        StageManager.Init_Func();
        cameraSystem_Manager.Init_Func();
        soundSystem_Manager.Init_Func();

        uI_DialogManager.Init_Func();
        uI_Status_Manager.Init_Func();
        uI_SceneChange_Manager.Init_Func();
        uI_Intro_Manager.Init_Func();
        uI_Victory_Manager.Init_Func();

        uI_Intro_Manager.Start_Func();
    }
}
