﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using DG.Tweening;
using UnityEngine.SceneManagement;
using Sirenix.OdinInspector;

public class UI_SceneChange_Manager : MonoBehaviour
{
    public static UI_SceneChange_Manager Instance;

    [BoxGroup("공통")] [SerializeField] private GameObject groupObj;

    [BoxGroup("최초")] [SerializeField] private GameObject stageInfoGroupObj;
    [BoxGroup("최초")] [SerializeField] private Image bgImg;
    [BoxGroup("최초")] [SerializeField] private Text stageTxt;
    
    [BoxGroup("신문")] [SerializeField] private GameObject newsPaperGroupObj;
    [BoxGroup("신문")] [SerializeField] private Animation newsPaperAnim;
    [BoxGroup("신문")] [SerializeField] private Image newsPaperImg;
    [BoxGroup("신문")] [SerializeField] private Sprite[] newsPaperSpriteArr;
    [BoxGroup("신문")] [SerializeField] private Sprite[] newsPaperSpriteArr_Defeat;
    [BoxGroup("신문")] [SerializeField] private Sprite newsPaperSprite_Rolling;
    [BoxGroup("신문")] [SerializeField] private GameObject newsPaperUiGroupObj;
    [BoxGroup("신문")] [SerializeField] private Image newspaperBtnImg;
    [BoxGroup("신문")] [SerializeField] private Sprite newsPaperNextBtnSprite;
    [BoxGroup("신문")] [SerializeField] private Sprite newsPaperRetryBtnSprite;

    private StepType stepType;
    private bool isClear;

    public void Init_Func()
    {
        Instance = this;

        groupObj.SetActive(false);

        stepType = StepType.None;
    }
    public void StartStage_Func(int _startStageId)
    {
        stageTxt.text = StringBuilder_C.Append_Func("Day ", _startStageId.ToString());

        stageTxt.SetFade_Func(0f);
        bgImg.SetFade_Func(1 < _startStageId ? 0f : 1f);
        groupObj.SetActive(true);
        stageInfoGroupObj.SetActive(true);

        StartCoroutine(StageStart_Cor(_startStageId));
    }
    private IEnumerator StageStart_Cor(int _nextStageId)
    {
        if (1 < _nextStageId)
        {
            bgImg.DOFade(1f, 1f);

            yield return Coroutine_C.GetWaitForSeconds_Cor(0.5f);
        }

        Tween _twn = stageTxt.DOFade(1f, 1f);

        SoundSystem_Manager.Instance.PlaySfx_Func(SoundSystem_Manager.SfxType.NextDay);

        yield return _twn.WaitForCompletion();

        this.newsPaperGroupObj.SetActive(false);

        StageSystem_Manager.Instance.StartStage_Func(_nextStageId);

        stageTxt.DOFade(0f, 1f);
        _twn = bgImg.DOFade(0f, 1f);

        yield return _twn.WaitForCompletion();

        groupObj.SetActive(false);
        stageInfoGroupObj.SetActive(false);
    }
    public void StageClear_Func()
    {
        this.isClear = true;

        this.RollingNewsPaper_Func();
    }
    public void StageOver_Func()
    {
        this.isClear = false;

        this.RollingNewsPaper_Func();
    }
    private void RollingNewsPaper_Func()
    {
        groupObj.SetActive(true);
        newsPaperGroupObj.SetActive(true);

        stepType = StepType.NewsPaperStart;

        this.newsPaperAnim.Play();
        
        newsPaperUiGroupObj.gameObject.SetActive(false);

        newsPaperImg.SetNativeSize_Func(this.newsPaperSprite_Rolling);

        SoundSystem_Manager.Instance.PlaySfx_Func(SoundSystem_Manager.SfxType.News);
    }
    
    public void CallAni_Func(string _key)
    {
        if(_key == "NewsPaper")
        {
            newsPaperUiGroupObj.gameObject.SetActive(true);

            Sprite _newsPaperSprite = null;
            Sprite _newsPaperBtnSprite = null;
            if (this.isClear == true)
            {
                int _nextStageId = StageSystem_Manager.Instance.StageId;
                _newsPaperSprite = newsPaperSpriteArr[_nextStageId - 1];
                newsPaperImg.SetNativeSize_Func(_newsPaperSprite);

                _newsPaperBtnSprite = this.newsPaperNextBtnSprite;
            }
            else
            {
                _newsPaperSprite = this.newsPaperSpriteArr_Defeat.GetRandItem_Func();
                _newsPaperBtnSprite = this.newsPaperRetryBtnSprite;
            }

            newsPaperImg.SetNativeSize_Func(_newsPaperSprite);
            newspaperBtnImg.sprite = _newsPaperBtnSprite;

        }
        else if(_key == "Done")
        {
            stepType = StepType.NewsPaperDone;
        }
    }
    public void CallBtn_Func()
    {
        if(stepType == StepType.NewsPaperDone)
        {
            if(isClear == true)
            {
                stepType = StepType.NextDay;

                int _nextStageId = StageSystem_Manager.Instance.StageId;
                this.StartStage_Func(_nextStageId + 1);
            }
            else
            {
                SceneManager.LoadScene(0);
            }
        }
    }

    public enum StepType
    {
        None = 0,
        NewsPaperStart,
        NewsPaperDone,
        NextDay,
        GameOver,
    }
}
